// Stringindeximplementierung
// verwendet binäre Suche um einen Index für einen Textstring zu erstellen
// indirektes Sortieren;
// Anordnen der Teilstrings in einem binären Suchbaum

class TI {
    private String text;
    private int[] index;
    private int N;
    TI(String s) {
	text = s; N = text.length();
        index = new int[N+1]; index[N] = -1;
        for (int i = 0; i < N; i++)
          index[i] = i;
        quicksort(index, 0, N-1);
    }
    private char s(int i) {
	return text.charAt(i);
    }
    private boolean less(int v, int w) { 
        if (v == w) return false;
        for (int i = 0; ; i++)
          if (w+i >= N) return false;
          else if (v+i >= N) return true;
          else if (s(v+i) < s(w+i)) return true;
          else if (s(v+i) > s(w+i)) return false;
    }
    private void exch(int[] a, int i, int j) {
	int t = a[i]; a[i] = a[j]; a[j] = t;
    }
    private void quicksort(int[] a, int l, int r) { 
    	if (r <= l) return;
    	int i = partition(a, l, r);
    	quicksort(a, l, i-1);
    	quicksort(a, i+1, r);
    }
    private int partition(int a[], int l, int r) {
	int i = l-1, j = r; int v = a[r];
    	for (;;) { 
        	while (less(a[++i], v)) ;
        	while (less(v, a[--j])) if (j == l) break;
        	if (i >= j) break;
        	exch(a, i, j);
        }
    	exch(a, i, r);
    	return i;
    }
    private int compare(String s, int v) {
	char[] key = s.toCharArray(); 
    	int t = index[v];
    	for (int i = 0; i < key.length; i++)
      		if (t+i >= N) return 1;
      		else if (key[i] > s(t+i)) return 1;
      		else if (key[i] < s(t+i)) return -1;
    	return 0;
    }
    private int searchR(int l, int r, String v) {
	int m = (l+r)/2;
    	if (l > r) return N;
    	switch (compare(v, m)) {
        	case -1: return searchR(l, m-1, v);
        	case  1: return searchR(m+1, r, v);
        }
    	return m; // case 0
    }
    int search(String v) {
	return index[searchR(0, N-1, v)]; 
    }
}
